unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Grids,
  StdCtrls, ExtCtrls, CheckLst, DBGrids, memds, db, LCLType;

type

  { TTableAddForm }

  TTableAddForm = class(TForm)
    CheckListBox1: TCheckListBox;
    CheckListBox2: TCheckListBox;
    ComboBox1: TComboBox;
    StringGrid1: TStringGrid;
    procedure CheckListBox1Exit(Sender: TObject);
    procedure ComboBox1EditingDone(Sender: TObject);
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure StringGrid1SelectEditor(Sender: TObject; aCol, aRow: Integer;
      var Editor: TWinControl);
  public
  end;

var
  TableAddForm: TTableAddForm;

implementation

{ TTableAddForm }

procedure TTableAddForm.FormCreate(Sender: TObject);
var
  y: Integer;
  x: Integer;
begin
  // fill the grid
  for y:=0 to StringGrid1.ColCount-1 do begin
    for x:=0 to StringGrid1.RowCount-1 do begin
      StringGrid1.Cells[x,y]:=IntToStr(x)+','+IntToStr(y);
    end;
  end;
end;

procedure TTableAddForm.FormShow(Sender: TObject);
begin

end;

procedure TTableAddForm.StringGrid1DrawCell(Sender: TObject; aCol,
  aRow: Integer; aRect: TRect; aState: TGridDrawState);
begin

end;

procedure TTableAddForm.ComboBox1EditingDone(Sender: TObject);
begin
  StringGrid1.Cells[StringGrid1.Col,StringGrid1.Row]:=(Sender as TComboBox).Text;
end;

procedure TTableAddForm.ComboBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
     //(Sender as TComboBox).DoExit;
end;

procedure TTableAddForm.CheckListBox1Exit(Sender: TObject);
begin
   with StringGrid1 do
  begin
       Cells[Col,Row] := BoolToStr(CheckListBox1.Checked[0],true);
  end;
end;

procedure TTableAddForm.StringGrid1SelectEditor(Sender: TObject; aCol, aRow: Integer;
  var Editor: TWinControl);
begin
  if aRow=0 then Exit;
  case aCol of
       0: begin
          CheckListBox1.Checked[0] := false;

          CheckListBox1.BoundsRect := StringGrid1.CellRect(aCol,aRow);
          if StringGrid1.Cells[aCol,aRow] = 'True' then
             CheckListBox1.Checked[0] := true;

          Editor := CheckListBox1;
          end;
       {1: begin
          ComboBox2.BoundsRect:=StringGrid1.CellRect(aCol,aRow);
          ComboBox2.Text:=StringGrid1.Cells[StringGrid1.Col,StringGrid1.Row];
          Editor:=ComboBox2;
          end;
       }2: begin
          ComboBox1.BoundsRect:=StringGrid1.CellRect(aCol,aRow);
          ComboBox1.Text:=StringGrid1.Cells[StringGrid1.Col,StringGrid1.Row];
          Editor:=ComboBox1;
          end;
        4: begin
           CheckListBox2.BoundsRect:=StringGrid1.CellRect(aCol,aRow);
           //ComboBox2.Text:=StringGrid1.Cells[StringGrid1.Col,StringGrid1.Row];
           Editor := CheckListBox2;
           end;
  end;
end;

initialization
  {$I unit1.lrs}

end.

